<?php

class fields_box_builder
{
  function fields_box_builder()
  {
  }

  function build($boxes, $groups)
  {
    foreach ($boxes as $key => $box)
    {
      $post_types = $box['post_types'];
      if (is_array($post_types)) {
        foreach ($post_types as $k => $post_type)
        {
          add_meta_box($key, $box['title'], array($this, 'build_box'), $post_type, 'advanced', 'high', 
            array(
              'box' => $box,
              'boxes' => $boxes,
              'groups' => $groups
            ));
        }
      }
    }    
  }
  
  function build_box($post, $metabox)
  {
    $boxes = $metabox['args']['boxes'];
    $groups = $metabox['args']['groups'];
    $box = $metabox['args']['box'];
    
    $g = $box['groups'];
    if ((sizeof($groups) > 0) && (is_array($g)) && (sizeof($g) > 0))
    {
      $box_id = 'fields-box-' . $box['box_key'];
      $box['id'] = $box_id;
      $box_groups = $this->get_groups($box, $groups);
      
      echo "<div class='categorydiv fields-box' id='$box_id'>";
      $this->build_tabs($post, $box, $box_groups);
      foreach ($box_groups as $group)
      {
        $this->build_group($post, $box, $group);
      }
      
      echo '<div class="cut"></div></div>';
    }
    else
    {
      echo "<p>No group included</p>";
      return;
    }        
  }
  
  function get_group($group_key, $groups)
  {
    foreach ($groups as $key => $group)
    {
      if (strcasecmp($group['group_key'], $group_key) == 0)
      {
        return $group;
      }
    }
    return false;
  }
  
  // get a list of groups that belong to a box
  function get_groups($box, $groups)
  {
    $arr = array();
    foreach ($box['groups'] as $group_key)
    {
      $group = $this->get_group($group_key, $groups);
      $group['id'] = $tab_id = $box['id'] . '-' . $group['group_key'];
      if (is_array($group))
        array_push($arr, $group);
    }
    sort_by_order(&$arr);
    return $arr;
  }
  
  function build_tabs($post, $box, $box_groups) 
  {
    echo '<ul class="category-tabs">';
    $i = 0;  
    foreach ($box_groups as $group)
    {      
      $group_id = $group['id'];
      $tab_id = $group['id'] . '-tab';
      $title = $group['title'];
      if ($i++ == 0)
        $class = "tabs group-tab";
      else
        $class = "hide-if-no-js group-tab";
      echo "<li class='" . $class . "' id='$tab_id'><a tabindex='3' href='#$group_id'>$title</a></li>";
    }
    echo '</ul>';
  }
  
  function build_group($post, $box, $group)
  {
    $group_id = $group['id'];
    echo "<div class='tabs-panel' id='$group_id'>\n" .
         "<table><tbody>";
    if (is_array($group['fields']))
    {
      foreach ($group['fields'] as $field)
      {
        $this->build_field($post, $box, $field);
      }
    }
    echo "</tbody></table></div>";
  }
  
  function build_field($post, $box, $field)
  {
    $field['id'] = 'tag-' . $box['id'] . '-' . $field_key;
    echo '<tr class="fields-field">';
    do_action(BUILD_SHOW . $field['type'], $post, $box, $field);
    echo '</tr>';
  }
  
  /* Save */
  function save($postID, $post)
  {
    if (@constant( 'DOING_AUTOSAVE')) return $post;
		if (!$_POST) return $post;
		if (!in_array($_POST['action'], array('editpost', 'post'))) return $post;

		$post_id = esc_attr($_POST['post_ID']);
		if (!$post_id) $post_id = $new_post_id;
		if (!$post_id) return $post;
		
		if ( $p = wp_is_post_revision($postID)) $postID = $p;  
    $fields = $this->filter_valid_fields($post_type);
    if (is_array($fields))
    {
      foreach ($fields as $field)
      {
        $this->save_field($postID, $field);
      }
    }
  }
    
  function filter_valid_fields($post_type)
  {
    global $boxes, $groups;
    $inputs = $_POST[META_FIELD];
    $box_fields = array();
    $fields = array();
    foreach ($boxes as $box)
    {
      if (is_array($box['groups']))
      {
        foreach ($box['groups'] as $group_key)
        {
          $group = $groups[$group_key];
          if (is_array($group['fields']))
          {
            foreach ($group['fields'] as $field)
            {
              if (isset($inputs[$field['field_key']]))
              {
                $field['post_value'] = $inputs[$field['field_key']];
                array_push($fields, $field);
              }
            }
          }
        }
      }
    }
    return $fields;
  }  
  
  function save_field($postID, $field)
  {            
    do_action(BUILD_SAVE . $field['type'], $postID, $field);
  }
}

?>