<?php

// Textfield
function show_textfield($post, $box, $field)
{
  include('fields-attr.inc');
  $load_default = true;
  if ($field['note'])
    $note = '<p class="description">' . $field['note'] . '</p>';
      
  if ($field['text_multi'] != '')
  {
    $meta = field_get_meta($field_key, false);
    $field_name .= '[]';
    $add_more = 
      "<div class='textfield-add-wrap'>".
      "<a class='button textfield-add' href='#'>" . __('Add more', 'fields') . '</a>'.
      "<a class='button textfield-cleanup' href='#'>" . __('Clean up', 'fields') . '</a>'.
      '</div>';
    // load from meta
    if (is_array($meta))
    {
      // build from order
      $values = array();
      foreach ($meta as $v)
      {
        $v = maybe_unserialize($v);        
        if (is_array($v))
          array_push($values, $v);
        else
        {
          $arr = array('order' => 0, 'value' => $v);
          array_push($values, $arr);
        }
      }
      sort_by_order(&$values);      
      
      if (sizeof($meta) > 1)
      {
        $index = 0;
        foreach ($values as $value)
        {
          $value = maybe_unserialize($value);
          if ($index++ == 0)
          {
          echo "<th valign='top' scope='row'><label for='$field_id'>$field_title</label></th>" .
               "<td class='sortable' valign='top'><div class='textfield-row'><a class='sort-handle'></a><input type='text' aria-required='true' value='{$value['value']}' id='$field_id' name='$field_name' /></div>" ;
          }
          else
          {
            echo 
              '<div class="textfield-row multi">'.
              '<a class="sort-handle"></a>'.
              "<input type='text' aria-required='true' value='{$value['value']}' id='$field_id' name='$field_name' /><a href='#' tabindex='-1' class='remove-textfield'><span></span></a>".
              '</div>';
          }
        }
        
        echo $note . $add_more . '</td>';        
      }
      else
      {
        list($k, $meta) = each($meta);
        echo "<th valign='top' scope='row'><label for='$field_id'>$field_title</label></th>" .
             "<td class='sortable' valign='top'><div class='textfield-row'><a class='sort-handle'></a>".
             "<input type='text' aria-required='true' value='{$value['value']}' id='$field_id' name='$field_name' /></div>".
             $note . $add_more . '</td>';
      }
      $load_default = false;
    }
  }
  else
  {
    $meta = field_get_meta($field_key);
  }
  if ($load_default)
    echo "<th valign='top' scope='row'><label for='$field_id'>$field_title</label></th>" .
         "<td class='sortable' valign='top'><div class='textfield-row multi'><input type='text' aria-required='true' value='$meta' id='$field_id' name='$field_name' />" .
         $note . $add_more;
         '</td>';
}

function save_textfield($postID, $field)
{
  //$oDebug = wp_pear_debug::get();
  //$oDebug->add($field['text_multi']);
  field_delete_meta($postID, $field['field_key']);
  $esc = $field['text_escape'] != '';
  if ($field['text_multi'])
  {
    if (is_array($field['post_value']))
    {
      $index = 0;
      foreach ($field['post_value'] as $value)
      {
        if ($esc)
          $value = esc_attr($value);
        $arr = array('order' => $index++, 'value' => $value);
        field_add_meta($postID, $field['field_key'], serialize($arr));
      }      
     // $oDebug->error("l2");
    }
  }
  else
  {
    $value = $field['post_value'];
    if ($esc)
      $value = esc_attr($value);
    field_update_meta($postID, $field['field_key'], $value);
  }
}

// textfield- admin panel
function show_textfield_options($str, $field)
{
  // edit field form
  if (is_array($field))
  {
    if ($field['text_multi'] != '') $checked_multi = ' checked'; else $checked_multi = '';
    if ($field['text_escape'] != '') $checked_escape = ' checked'; else $checked_escape = '';
    return $str . 
      '<tr class="additional text-linked">'.
    	'	<th valign="top" scope="row"></th>'.
    	'	<td valign="middle"><input type="checkbox"'.$checked_multi.' name="text-multi" id="tag-text-multi" /><label class="input-label" for="tag-text-multi">Multiple values</label>'.
    	' <p class="description">' . __('users will be able to add multiple values to this field', 'fields') . '</p>'.
    	'</td></tr>'.

      '<tr class="additional text-linked">'.
    	'	<th valign="top" scope="row"></th>'.
    	'	<td><input type="checkbox"'.$checked_escape.' name="text-escape" id="tag-text-escape" /><label class="input-label" for="tag-text-escape">Escape HTML tags</label>'.
    	' <p class="description">' . __('encode HTML tags', 'fields') . '</p>'.
    	'</td></tr>';
  }
  // add field form
  else
  {
    return $str .      
      '<div class="form-field form-required additional text-linked">'.
      '	<input type="checkbox" name="text-multi" id="tag-text-multi" /><label class="input-label" for="tag-text-multi">Multiple values</label>'.
      '</div>'.
      
      '<div class="form-field form-required additional text-linked">'.
      '	<input type="checkbox" checked name="text-escape" id="tag-text-escape" /><label class="input-label" for="tag-text-escape">Escape HTML tags</label>'.
      '</div>';            
  }
}

function save_textfield_options($field, $group)
{
  $field['text_multi'] = esc_attr($_POST['text-multi']);
  $field['text_escape'] = esc_attr($_POST['text-escape']);
  return $field;
}

?>